// Kozak's Jisho v2.4a - Kana Kanji henkan engine by N's LAB Copyright (C) 2006-2007 by Nobumichi Kozawa
import javax.microedition.io.*;
import javax.microedition.rms.*;
import javax.microedition.lcdui.*;
import java.io.*;

public class Jisho
{
	private String sFileName;
	private String sWord, sRemain;
	private byte[] indexCache;
	private String[] wordCache;
	private String[] contCache;
	private byte[] hashCache;
	private boolean[] stCache;
	private int iCachePos;
	private char[][] caMemDict;
	private char[] caMD;
// LECMTS
/*
	private String[] wordUdic;
	private String[] contUdic;
	private byte[] hashUdic;
	private int iNumUdic = 100;
*/
// LECMTE
	private boolean bCacheMode = true;
	private boolean bNeedOpenDic = true;
	private boolean bFirstV = false;
	public boolean bCN = false;
	private int idx;
	private Vect v, vCurrent, vBase;
	private char cIni;
	private String sPre = "";
	public String sError;
	public StringBuffer sbDebug;
	public static byte dicVersion = 3;
	public static byte dicType = 0; // 0 - M, 1 - ML .... no longer needed :)
	private InputStream in = null;
	private InputStreamReader isn = null;
	private static String enc = "UTF-8";	// Cache has to be enc/dec in UTF-8
	public int iCacheHit, iTotalHit;
	public static int iNumCacheEntries = 128;
	public static int iNumStCache = 16;		// Number of sticky cache entries
	public static int iCacheSize = 2560;
	private static String sSetuzokusi = "Ăɂ͂Ƃł";
	public boolean bLoadIndex, bMemDic;
	public String sUdicErr = null;
	
	public Jisho()
	{
		v = new Vect();
		idx = -1;
		setDictName();
		sError = "";
		if (!(bLoadIndex = loadIndex())) {
			storeIndex();
		}
		KKJConv.bCN = bCN;
/*		else {
			if (KKJConv.bCN && !bCN) {
				bCN = true;
				if (indexJisho(sFileName)) storeIndex();
			}
		}*/
		sbDebug = new StringBuffer();
// LECMTS
/*
		if (1 == KKJConv.bUserDict) loadUdic();
		else iNumUdic = 0;
*/
// LECMTE
		cacheInit();
		bMemDic = KKJConv.bMemDic;
		if (bMemDic) loadDict();
	}
	
	private void setDictName()
	{
		sFileName = "/SKK-JISYO.M";
		in = getClass().getResourceAsStream(sFileName);
		if (null == in) {
			sFileName = "/SKK-JISYO.MML";
			in = getClass().getResourceAsStream(sFileName);
			if (null == in) {
				sFileName = "/SKK-JISYO.L";
				in = getClass().getResourceAsStream(sFileName);
			}
		}
		try {
			if (null == in) sError = "Dictionary Resource Open Failure.";
			else in.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
		in = null;
	}
	
	private void cacheInit()
	{
		iCacheHit = iTotalHit = 0;
		indexCache = new byte[iNumCacheEntries];
		hashCache = new byte[iNumCacheEntries];
		wordCache = new String[iNumCacheEntries];
		contCache = new String[iNumCacheEntries];
		stCache = new boolean[iNumCacheEntries];
		for (int i = 0; i < iNumCacheEntries; i++) {
			indexCache[i] = (byte)i;
			hashCache[i] = 0;
			stCache[i] = false;
		}
		iCachePos = -1;
		loadCache();
	}
	
	private void loadDict()
	{
		int count, idat;
		char cdat;
		caMemDict = new char[45][];
		StringBuffer sb = new StringBuffer();
		
		for (int i = 1; i <= 45; i++) {
			try {
				sbDebug.append("loadDict open ");
				in = getClass().getResourceAsStream(sFileName + "." + i);
				isn = new InputStreamReader(in, "UTF-8");
				count = 0;
				sb.delete(0, sb.length());
				while (-1 != (idat = isn.read())) {
					count++;
					cdat = (char)idat;
					if (0x0a == cdat) break;
					else if (0x0d == cdat) continue;
					else if (';' == cdat) continue;
					else sb.append(cdat);
				}
				in.close();
				if (0 < count) {
					count += Integer.parseInt(sb.toString());
					caMD = new char[count];
					in = getClass().getResourceAsStream(sFileName + "." + i);
					isn = new InputStreamReader(in, "UTF-8");
					isn.read(caMD, 0, count);
				} else {
					caMD = null;
				}
				caMemDict[i - 1] = caMD;
			} catch (IOException e) {
				sbDebug.append("" + e);
				sError = "loadDict: " + e;
			}
			try {
				in.close();
			} catch (IOException e) {}
		}
		in = null;
	}
	
// LECMTS
/*
	private void loadUdic()
	{
		int idat, i = 0;
		char cdat;
		StringBuffer sbDic;
		StringBuffer sbCnt;
		boolean bFirst = true, bCmt = false, bDicWord = true;
		FileConnection fc = null;
		InputStream is = null;
		byte[] ba;
		RecordStore rs = null;
		
		String fn = "E:/KKJConv/KKJUser.dic";
		try {
    		rs = RecordStore.openRecordStore("KKJUdic", false);
    		ba = rs.getRecord(1);
    		fn = new String(ba, "UTF-8");
    	} catch (Exception e) {
    	} finally {
    		try {
    			if (null != rs) rs.closeRecordStore();
    		} catch (Exception e) {
    			e.printStackTrace();
    		}
    	}

		sbDic = new StringBuffer();
		sbCnt = new StringBuffer();
		wordUdic = new String[iNumUdic];
		contUdic = new String[iNumUdic];
		hashUdic = new byte[iNumUdic];
		try {
			fc = (FileConnection)Connector.open("file:///" + fn, Connector.READ);
			if (!fc.exists()) {
				throw new IOException("User Dictionary not found. fn=" + fn);
			}
			is = fc.openInputStream();
			InputStreamReader isr = new InputStreamReader(is, "UTF-8");
			loop_read:
			while (-1 != (idat = isr.read())) {
				cdat = (char)idat;
				switch (cdat) {
					case 0x0a :
					case 0x0d :
						if (sbDic.length() > 0 && sbCnt.length() > 0) {
							wordUdic[i] = sbDic.toString().trim();
							contUdic[i] = sbCnt.toString().trim();
							hashUdic[i] = getHash(wordUdic[i]);
							i++;
							if (i >= iNumUdic) break loop_read;
						}
						sbDic.delete(0, sbDic.length());
						sbCnt.delete(0, sbCnt.length());
						bCmt = false;
						bFirst = bDicWord = true;
						break;
					case '@' :
					case ' ' :
						bFirst = bDicWord = false;
						break;
					case ';' :
						if (bFirst) {
							bCmt = true;
							bFirst = false;
						}
						break;
					default :
						if(!bCmt) {
							if (bDicWord) sbDic.append(cdat);
							else sbCnt.append(cdat);
						}
						bFirst = false;
				}
			}
		} catch (Exception e) {
			sUdicErr = "" + e + ", " + sbDic;
			e.printStackTrace();
		} finally {
			try {
				if (null != is) is.close();
				if (null != fc) fc.close();
			} catch (IOException e) {
			}
		}
	}
*/
// LECMTE
	
	private void loadCache()
	{
		RecordStore rsw = null, rsc = null, rss = null;
		byte[] ba;
		int i, iPos, iWord, iCont;
		
		try {
			rsw = RecordStore.openRecordStore("kjCache", false);
		} catch (Exception e) {
			loadCache2();
		}
		try {
			ba = rsw.getRecord(1);
			if (0 < ba.length) {
				iPos = iWord = iCont = 0;
				for (i = 0; i < ba.length; i++) {
					if (0 == ba[i]) {
						if (i == iPos) break;
						if (iWord == iCont) {
							wordCache[iWord] = new String(ba, iPos, i - iPos, enc);
							hashCache[iWord] = getHash(wordCache[iWord]);
							iWord++;
							if (iWord >= iNumCacheEntries) break;
						} else {
							contCache[iCont] = new String(ba, iPos, i - iPos, enc);
							if (contCache[iCont].startsWith("\r")) {
								stCache[iCont] = true;
								contCache[iCont] = contCache[iCont].substring(1);
							} else stCache[iCont] = false;
							iCont++;
							if (iCont >= iNumCacheEntries) break;
						}
						iPos = i + 1;
					}
				}	
				iCachePos = iCont - 1;
			}
			// statistical data
			ba = new byte[4];
			rss = RecordStore.openRecordStore("statCache", false);
			ba = rss.getRecord(1);
			iCacheHit = ba2int(ba);
			ba = rss.getRecord(2);
			iTotalHit = ba2int(ba);
		} catch (Exception e) {
//			sError = "loadIndex: " + e;
//			e.printStackTrace();
		} finally {
			try {
				if (null != rsw) rsw.closeRecordStore();
				if (null != rss) rss.closeRecordStore();
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
	}

	private void loadCache2()
	{
		RecordStore rsw = null, rsc = null, rss = null;
		byte[] ba;
		int i;
		
		try {
			rsw = RecordStore.openRecordStore("wordCache", false);
			rsc = RecordStore.openRecordStore("contCache", false);
			for (i = 0; i < rsw.getNumRecords(); i++) {
				ba = rsw.getRecord(i + 1);
				if (0 == ba.length) break;
				wordCache[i] = new String(ba, enc);
				hashCache[i] = getHash(ba);
				ba = rsc.getRecord(i + 1);
				if (0 == ba.length) break;
				contCache[i] = new String(ba, enc);
			}
			iCachePos = i - 1;
			// statistical data
			ba = new byte[4];
			rss = RecordStore.openRecordStore("statCache", false);
			ba = rss.getRecord(1);
			iCacheHit = ba2int(ba);
			ba = rss.getRecord(2);
			iTotalHit = ba2int(ba);
		} catch (Exception e) {
//			sError = "loadIndex: " + e;
//			e.printStackTrace();
		} finally {
			try {
				if (null != rsw) rsw.closeRecordStore();
				if (null != rsc) rsc.closeRecordStore();
				if (null != rss) rss.closeRecordStore();
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
		delOldCache();
	}

	private void delOldCache()
	{
		try {
			RecordStore.deleteRecordStore("wordCache");
			RecordStore.deleteRecordStore("contCache");
			sError = "Old Cache was deleted.";
		} catch (Exception e) {
		}
	}
	
	private int ba2int(byte[] ba)	// ba has to be 4 bytes array
	{
		int i = 0;
		for (int j = 3; j >= 0; j--) {
			i *= 128;
			i += ba[j];
		}
		return i;
	}
	
	private byte[] int2ba(int i)
	{
		byte [] ba = new byte[4];
		int iWork = i;
		for (int j = 0; j < 4; j++) {
			ba[j] = (byte)(iWork % 128);
			iWork /= 128;
		}
		return ba;
	}
	
	private byte getHash(String s)
	{
		try {
			byte [] ba = s.getBytes(enc);
			return getHash(ba);
		} catch (UnsupportedEncodingException e) {}
		return (byte)0;
	}
	
	private byte getHash(byte[] ba)
	{
		if (ba.length < 3) return 0;
		return ba[2];
	}
	
	public void storeCache()
	{
		byte[] ba;
		byte[] bCache = new byte[iCacheSize];
		String sCwFlag;
		int i, j, ix, iBytes = 0;
		
		try {
			try {
				RecordStore.deleteRecordStore("kjCache");
			} catch (RecordStoreNotFoundException e) {
			}
			RecordStore rsw = RecordStore.openRecordStore("kjCache", true);
			for (i = 0; i <= iCachePos; i++) {
				ix = indexCache[i];
				ba = wordCache[ix].getBytes(enc);
				if (iCacheSize < iBytes + ba.length + 2) break;
				for (j = 0; j < ba.length; j++) bCache[j + iBytes] = ba[j];
				bCache[iBytes + ba.length] = 0;
				iBytes += ba.length + 1;
				sCwFlag = (stCache[ix]) ? "\r" : "";
				ba = (sCwFlag + contCache[ix]).getBytes(enc);
				if (iCacheSize < iBytes + ba.length + 2) break;
				for (j = 0; j < ba.length; j++) bCache[j + iBytes] = ba[j];
				bCache[iBytes + ba.length] = 0;
				iBytes += ba.length + 1;
			}
			bCache[iBytes] = 0;
			if (iBytes + 1 < iCacheSize) bCache[iBytes + 1] = 0;
			rsw.addRecord(bCache, 0, bCache.length);
			rsw.closeRecordStore();
			// statistical data
			ba = new byte[4];
			try {
				RecordStore.deleteRecordStore("statCache");
			} catch (RecordStoreNotFoundException e) {
			}
			RecordStore rss = RecordStore.openRecordStore("statCache", true);
			ba = int2ba(iCacheHit);
			rss.addRecord(ba, 0, 4);
			ba = int2ba(iTotalHit);
			rss.addRecord(ba, 0, 4);
			rss.closeRecordStore();
		} catch (Exception e) {
			sError = "storeIndex: " + e;
			e.printStackTrace();
		}
	}
	
	public String cacheStatusReport(char paraSepa)
	{
		int [] ia = new int[256];
		int i = 0, iHashCount = 0, iBytes = 0, iRatio2;
		long lRatio1;
		byte [] ba;
		StringBuffer sb = new StringBuffer();
		try {
			for (i = 0; i < 256; i++) ia[i] = 0;
			for (i = 0; i <= iCachePos; i++) {
				ia[hashCache[i]+128] = 1;
				ba = wordCache[i].getBytes(enc);
				iBytes += ba.length + 1;
				ba = contCache[i].getBytes(enc);
				iBytes += ba.length + 1;
			}
		} catch (Exception e) {
			sb.append("" + hashCache[i]);
			e.printStackTrace();
		}
		for (i = 0; i < 256; i++) iHashCount += ia[i];
		lRatio1 = iCacheHit;
		lRatio1 *= 10000l;
		lRatio1 = (0 == iTotalHit) ? 0l : lRatio1 / (long)iTotalHit;
		iRatio2 = (int)(lRatio1 % 100l);
		lRatio1 /= 100l;
		
		sb.append("[ Cache Statistical Summary ]" + paraSepa);
		sb.append(" Cache hit ratio : " + lRatio1 + "." + iRatio2 + "%" + paraSepa);
		sb.append(" Total cache hit = " + iCacheHit + paraSepa);
		sb.append(" Total Retrieve = " + iTotalHit + paraSepa);
		sb.append(" Hash Variety : " + iHashCount + paraSepa);
		sb.append(" Number of cache entries = " + (iCachePos + 1) + paraSepa);
		sb.append(" Cache size = " + iBytes + " byte" + paraSepa);
		sb.append(" sError: " + sError + paraSepa);
//		sb.append(" sDebug: " + sbDebug.toString());
		return sb.toString();
	}
	
	public String printCache(char paraSepa)
	{
		int ix;
		StringBuffer sb = new StringBuffer();
		
// LECMTS
/*
		sb.append("User Dictionary" + paraSepa);
		for (int i = 0; i < iNumUdic; i++) {
			if (null == wordUdic[i]) break;
			sb.append(i + ", " + wordUdic[i] + ", " + contUdic[i] + paraSepa);
		}
*/
// LECMTE

		sb.append("Cache Entries" + paraSepa);
		for (int i = 0; i <= iCachePos; i++) {
			ix = indexCache[i];
			sb.append(ix + ", " + hashCache[ix] + ", " + wordCache[ix] + ", " + contCache[ix] + ((stCache[ix])?"*":"") + paraSepa);
		}
		return sb.toString();
	}
	
	public void kakutei()
	{
		int i, ix = 0;
//		byte hash = getHash(sPre + sWord);
		
		if (++iTotalHit < 0) iTotalHit = iCacheHit = 0;
		if (-2 == vCurrent.cachePosition) return;		// not enter cache
		if (0 <= (i = vCurrent.cachePosition)) {        // Cache hit
			if (stCache[indexCache[i]]) hitCacheIndex(i);
			else hitCacheIndex2(i);
			if (++iCacheHit < 0) iCacheHit = iTotalHit = 0;
			return;
		}
		if (iCachePos < iNumCacheEntries - 1) {			// No cache hit
			iCachePos++;
			ix = iCachePos;
			indexCache[iCachePos] = (byte)iCachePos;
		} else {
			ix = indexCache[iCachePos];
		}
		wordCache[ix] = vCurrent.cacheYomi;
		contCache[ix] = vCurrent.cacheWord;
		hashCache[ix] = getHash(vCurrent.cacheYomi);
		stCache[ix] = false;
		hitCacheIndex2(iCachePos);
	}

	public void kakutei(String yomi, String word)
	{
		int i, ix = 0;
		byte hash = getHash(yomi);
		
		if (++iTotalHit < 0) iTotalHit = iCacheHit = 0;
		
		if (0 <= vCurrent.cachePosition && hash == getHash(vCurrent.cacheYomi)) {
			if (0 == yomi.compareTo(vCurrent.cacheYomi) && 0 == word.compareTo(vCurrent.cacheWord)) {
				i = vCurrent.cachePosition;			// this may not happen
//				ix = indexCache[i];
				hitCacheIndex(i);
				if (++iCacheHit < 0) iCacheHit = iTotalHit = 0;
				return;
			}
		}
		if (iCachePos < iNumCacheEntries - 1) {
			iCachePos++;
			ix = iCachePos;
			indexCache[iCachePos] = (byte)iCachePos;
		} else {
			ix = indexCache[iCachePos];
		}
		wordCache[ix] = yomi;
		contCache[ix] = word;
		hashCache[ix] = hash;
		stCache[ix] = true;
		hitCacheIndex(iCachePos);
	}

	public void kakutei(int seq)
	{
		vCurrent = v;
		while (true) {
			if (seq == vCurrent.seq) {
				kakutei();
				break;
			}
			if (null == vCurrent.next) break;
			vCurrent = vCurrent.next;
			if (0 == vCurrent.seq) break;
		}
	}
	
	public void hitCacheIndex2(int indx)
	{
		int i, iTop = iNumStCache, ix = indexCache[indx];
		
		for (i = 0; i < iNumStCache; i++) {
			if (!stCache[indexCache[i]]) {
				iTop = i;
				break;
			}
		}
		
		for (i = indx; i > iTop; i--) {
			indexCache[i] = indexCache[i - 1];
		}
		indexCache[iTop] = (byte)ix;
	}

	public void hitCacheIndex(int indx)
	{
		int ix = indexCache[indx];
		
		for (int i = indx; i > 0; i--) {
			indexCache[i] = indexCache[i - 1];
		}
		indexCache[0] = (byte)ix;
	}
	
	public int getAll()
	{	
		while (v != vCurrent) getNext();
		return v.prev.seq + 1;
	}
	
	public int getCurrentSeq()
	{
		return vCurrent.seq;
	}
	
	public String getFirst()
	{
		return v.word;
	}
	
	public String getNext()
	{
		Vect vWork;
		
		if (null != vCurrent.next) {
			vCurrent = vCurrent.next;
		} else {
			if (null == (vWork = searchDict()))	{
				if (null == (vWork = setWord2())) {
					vCurrent = v;
					v.prev = v.getLast();
				}
				else vCurrent = vWork;
			}
			else vCurrent = vWork;
		}
		return vCurrent.word;
	}
	
	public String getPrev()
	{
		if (null != vCurrent.prev) {
			vCurrent = vCurrent.prev;
		}
		return vCurrent.word;
	}
	
	public Vect setWord2()
	{
		Vect v = null;
		
		if ('' == sWord.charAt(0) && 0 == sPre.compareTo("") && 1 < sWord.length()) {
			sPre = "";
			sWord = sWord.substring(1);
			cIni = sWord.charAt(0);
			idx = getIndx(cIni);
			if (!bMemDic) {
				try {
//					sbDebug.append("setWord2 in.close/open ");
					in.close();
					in = getClass().getResourceAsStream(sFileName + "." + idx);
					isn = new InputStreamReader(in, enc);
				} catch (IOException e) {
					sError = "setWord2: " + e;
					e.printStackTrace();
				}
			}
			v = searchDict();
		}
		
		return v;
	}
	
	public void setWord(String word, String roma)
	{
		bCacheMode = true;
		sPre = "";
		sWord = word;
		cIni = word.charAt(0);
		if (0 != roma.compareTo("")) {
			v.word = roma;
			v.cachePosition = -2;
			v.prev = v.next = null;
			vCurrent = v;
			setZenkaku(roma);
			bFirstV = false;
		} else bFirstV = true;
		setHanKana(word);
		setZenKana(word);
		setHiragana(word);
		vBase = vCurrent;
		idx = getIndx(cIni);
		bNeedOpenDic = true;
		if (!bMemDic) {
			try {
				if (null != in) {
//					sbDebug.append("setWord close ");
					in.close();
					in = null;
				}
			} catch (IOException e) {
				sError = "setWord in.close: " + e;
				e.printStackTrace();
			}
		}
	}
	
	private void setHiragana(String word)
	{
		Vect vWork, vWork2;
		if (bFirstV) {
			v.word = v.cacheWord = word;
			v.cacheYomi = word;
			v.cachePosition = -2;
			v.prev = v.next = null;
			vCurrent = v;
			bFirstV = false;
		} else {
			vWork = vCurrent.getLast();
			vWork2 = vWork.next = new Vect(vWork);
			vWork2.word = vWork2.cacheWord = word;
			vWork2.cacheYomi = word;
			vWork2.cachePosition = -2;
			vCurrent = vWork2;
		}
	}
	
	private void setZenKana(String word)
	{
		Vect vWork, vWork2;
		char c, r;
		int i;
		boolean bFlg = false;
		StringBuffer sbWork = new StringBuffer();
		
		for (i = 0; i < word.length(); i++) {
			c = word.charAt(i);
			switch (c) {
				case '' : r = 'A'; break;
				case '' : r = '@'; break;
				case '' : r = 'C'; break;
				case '' : r = 'B'; break;
				case '' : r = 'E'; break;
				case '' : r = 'D'; break;
				case '' : r = 'G'; break;
				case '' : r = 'F'; break;
				case '' : r = 'I'; break;
				case '' : r = 'H'; break;
				case '' : r = 'J'; break;
				case '' : r = 'K'; break;
				case '' : r = 'L'; break;
				case '' : r = 'M'; break;
				case '' : r = 'N'; break;
				case '' : r = 'O'; break;
				case '' : r = 'P'; break;
				case '' : r = 'Q'; break;
				case '' : r = 'R'; break;
				case '' : r = 'S'; break;
				case '' : r = 'T'; break;
				case '' : r = 'U'; break;
				case '' : r = 'V'; break;
				case '' : r = 'W'; break;
				case '' : r = 'X'; break;
				case '' : r = 'Y'; break;
				case '' : r = 'Z'; break;
				case '' : r = '['; break;
				case '' : r = '\'; break;
				case '' : r = ']'; break;
				case '' : r = '^'; break;
				case '' : r = '_'; break;
				case '' : r = '`'; break;
				case '' : r = 'a'; break;
				case '' : r = 'c'; break;
				case '' : r = 'b'; break;
				case '' : r = 'd'; break;
				case '' : r = 'e'; break;
				case '' : r = 'f'; break;
				case '' : r = 'g'; break;
				case '' : r = 'h'; break;
				case '' : r = 'i'; break;
				case '' : r = 'j'; break;
				case '' : r = 'k'; break;
				case '' : r = 'l'; break;
				case '' : r = 'm'; break;
				case '' : r = 'n'; break;
				case '' : r = 'o'; break;
				case '' : r = 'p'; break;
				case '' : r = 'q'; break;
				case '' : r = 'r'; break;
				case '' : r = 's'; break;
				case '' : r = 't'; break;
				case '' : r = 'u'; break;
				case '' : r = 'v'; break;
				case '' : r = 'w'; break;
				case '' : r = 'x'; break;
				case '' : r = 'y'; break;
				case '' : r = 'z'; break;
				case '' : r = '{'; break;
				case '' : r = '|'; break;
				case '' : r = '}'; break;
				case '' : r = '~'; break;
				case '' : r = ''; break;
				case '' : r = ''; break;
				case '' : r = ''; break;
				case '' : r = ''; break;
				case '' : r = ''; break;
				case '' : r = ''; break;
				case '' : r = ''; break;
				case '' : r = ''; break;
				case '' : r = ''; break;
				case '' : r = ''; break;
				case '' : r = ''; break;
				case '' : r = ''; break;
				case '' : r = ''; break;
				case '' : r = ''; break;
				case '' : r = ''; break;
				case '' : r = ''; break;
				case '' : r = ''; break;
				default   : r = c;
			}
			if (r != c) bFlg = true;
			sbWork.append(r);
		}
		if (bFlg) {
			if (bFirstV) {
				v.word = v.cacheWord = sbWork.toString();
				v.cacheYomi = word;
				v.cachePosition = -1;
				v.prev = v.next = null;
				vCurrent = v;
				bFirstV = false;
			} else {
				vWork = vCurrent.getLast();
				vWork2 = vWork.next = new Vect(vWork);
				vWork2.word = vWork2.cacheWord = sbWork.toString();
				vWork2.cacheYomi = word;
				vWork2.cachePosition = -1;
				vCurrent = vWork2;
			}
		}
	}

	private void setHanKana(String word)
	{
		Vect vWork, vWork2;
		char c;
		String r;
		int i;
		boolean bFlg = false, bFlg2;
		StringBuffer sbWork = new StringBuffer();
		
		for (i = 0; i < word.length(); i++) {
			c = word.charAt(i);
			bFlg2 = false;
			switch (c) {
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '' : r =""; break;
				case '[' : r =""; break;
				default   : r = new Character(c).toString();
				            bFlg2 = true;
			}
			sbWork.append(r);
			if (!bFlg2) bFlg = true;
		}
		
		if (bFlg) {
			if (bFirstV) {
				v.word = v.cacheWord = sbWork.toString();
				v.cacheYomi = word;
				v.cachePosition = -1;
				v.prev = v.next = null;
				vCurrent = v;
				bFirstV = false;
			} else {
				vWork = vCurrent.getLast();
				vWork2 = vWork.next = new Vect(vWork);
				vWork2.word = vWork2.cacheWord = sbWork.toString();
				vWork2.cacheYomi = word;
				vWork2.cachePosition = -1;
				vCurrent = vWork2;
			}
		}
	}

	private void setZenkaku(String roma)
	{
		Vect vWork, vWork2;
		char c, r;
		int i;
		boolean bFlg = false;
		StringBuffer sbWork = new StringBuffer();
		
		for (i = 0; i < roma.length(); i++) {
			c = roma.charAt(i);
        	switch (c) {
        		case '!' : r = 'I'; break;
        		case '"' : r = 'h'; break;
        		case '#' : r = ''; break;
        		case '$' : r = ''; break;
        		case '%' : r = ''; break;
        		case '&' : r = ''; break;
        		case '\'' : r = 'f'; break;
        		case '(' : r = 'i'; break;
        		case ')' : r = 'j'; break;
        		case '*' : r = ''; break;
        		case '+' : r = '{'; break;
        		case ',' : r = 'C'; break;
        		case '-' : r = '|'; break;
        		case '.' : r = 'D'; break;
        		case '/' : r = '^'; break;
        		case '0' : r = 'O'; break;
        		case '1' : r = 'P'; break;
        		case '2' : r = 'Q'; break;
        		case '3' : r = 'R'; break;
        		case '4' : r = 'S'; break;
        		case '5' : r = 'T'; break;
        		case '6' : r = 'U'; break;
        		case '7' : r = 'V'; break;
        		case '8' : r = 'W'; break;
        		case '9' : r = 'X'; break;
        		case ':' : r = 'F'; break;
        		case ';' : r = 'G'; break;
        		case '<' : r = ''; break;
        		case '=' : r = ''; break;
        		case '>' : r = ''; break;
        		case '?' : r = 'H'; break;
        		case '@' : r = ''; break;
        		case 'A' : r = '`'; break;
        		case 'B' : r = 'a'; break;
        		case 'C' : r = 'b'; break;
        		case 'D' : r = 'c'; break;
        		case 'E' : r = 'd'; break;
        		case 'F' : r = 'e'; break;
        		case 'G' : r = 'f'; break;
        		case 'H' : r = 'g'; break;
        		case 'I' : r = 'h'; break;
        		case 'J' : r = 'i'; break;
        		case 'K' : r = 'j'; break;
        		case 'L' : r = 'k'; break;
        		case 'M' : r = 'l'; break;
        		case 'N' : r = 'm'; break;
        		case 'O' : r = 'n'; break;
        		case 'P' : r = 'o'; break;
        		case 'Q' : r = 'p'; break;
        		case 'R' : r = 'q'; break;
        		case 'S' : r = 'r'; break;
        		case 'T' : r = 's'; break;
        		case 'U' : r = 't'; break;
        		case 'V' : r = 'u'; break;
        		case 'W' : r = 'v'; break;
        		case 'X' : r = 'w'; break;
        		case 'Y' : r = 'x'; break;
        		case 'Z' : r = 'y'; break;
        		case '[' : r = 'm'; break;
        		case '\\' : r = ''; break;
        		case ']' : r = 'n'; break;
        		case '^' : r = 'O'; break;
        		case '_' : r = 'Q'; break;
        		case '`' : r = 'e'; break;
        		case 'a' : r = ''; break;
        		case 'b' : r = ''; break;
        		case 'c' : r = ''; break;
        		case 'd' : r = ''; break;
        		case 'e' : r = ''; break;
        		case 'f' : r = ''; break;
        		case 'g' : r = ''; break;
        		case 'h' : r = ''; break;
        		case 'i' : r = ''; break;
        		case 'j' : r = ''; break;
        		case 'k' : r = ''; break;
        		case 'l' : r = ''; break;
        		case 'm' : r = ''; break;
        		case 'n' : r = ''; break;
        		case 'o' : r = ''; break;
        		case 'p' : r = ''; break;
        		case 'q' : r = ''; break;
        		case 'r' : r = ''; break;
        		case 's' : r = ''; break;
        		case 't' : r = ''; break;
        		case 'u' : r = ''; break;
        		case 'v' : r = ''; break;
        		case 'w' : r = ''; break;
        		case 'x' : r = ''; break;
        		case 'y' : r = ''; break;
        		case 'z' : r = ''; break;
        		case '{' : r = 'o'; break;
        		case '|' : r = 'b'; break;
        		case '}' : r = 'p'; break;
        		case '~' : r = '`'; break;
        		default: r = '@';
			}
			sbWork.append(r);
			if (r != '@') bFlg = true;
		}
		
		if (bFlg) {
			vWork = vCurrent.getLast();
			vWork2 = vWork.next = new Vect(vWork);
			vWork2.word = sbWork.toString();
			vWork2.cachePosition = -2;
			vCurrent = vWork2;
		}
	}

	private Vect searchDict()
	{
		Vect vFirst = null, vWork, vWork2 = vCurrent;
		int idat, i, ix;
		byte bHash;
		boolean bCacheHit = false;
		char cdat, cdat2;
		boolean bDic = true, bHit = false;;
		StringBuffer sbDic = new StringBuffer();
		StringBuffer sbCnt = new StringBuffer();
		String sWork;
		
		if (bCacheMode) {
			bHash = getHash(sWord);
// LECMTS
/*
			if (1 == KKJConv.bUserDict) {
				for (i = 0; i < iNumUdic; i++) {
					if (null == wordUdic[i] || null == contUdic[i]) break;
					if (bHash == hashUdic[i]) {
						if (sWord.startsWith(wordUdic[i])) {
							vWork = vWork2.getLast();
							vWork2 = vWork.next = new Vect(vWork);
							if (null == vFirst) vFirst = vWork2;
							sRemain = sWord.substring(wordUdic[i].length());
							vWork2.word = sPre + contUdic[i].toString() + sRemain;
							//vWork2.word = wordUdic[i] + ">" + contUdic[i].toString();
							vWork2.cacheWord = sPre + contUdic[i].toString();
							vWork2.cacheYomi = wordUdic[i];
							vWork2.cachePosition = -2;
							bCacheHit = true;
						}
					}
				}
			}
*/
// LECMTE
			for (i = 0; i <= iCachePos; i++) {
				ix = indexCache[i];
				if (bHash == hashCache[ix]) {
					if (sWord.startsWith(wordCache[ix])) {
						sRemain = sWord.substring(wordCache[ix].length());
						sWork = sPre + contCache[ix].toString() + sRemain;
						if (checkDup(sWork)) {
							vWork = vWork2.getLast();
							vWork2 = vWork.next = new Vect(vWork);
							if (null == vFirst) vFirst = vWork2;
//							sRemain = sWord.substring(wordCache[ix].length());
							vWork2.word = sWork;
							vWork2.cacheWord = sPre + contCache[ix].toString();
							vWork2.cacheYomi = wordCache[ix];
							vWork2.cachePosition = i;
							bCacheHit = true;
						}
					}
				}
			}
			bCacheMode = false;
		}
		if (!bCacheHit) {
			try {
				if (bNeedOpenDic && !bMemDic) {
					sbDebug.append("searchDict open ");
					in = getClass().getResourceAsStream(sFileName + "." + idx);
					isn = new InputStreamReader(in, "UTF-8");
					bNeedOpenDic = false;
				}
				i = 0;
				while (true) {
					if (bMemDic) {
						caMD = caMemDict[idx - 1];
						if (null == caMD || i >= caMD.length) break;
						cdat = caMD[i];
						i++;
					} else {
						if (-1 == (idat = isn.read())) break;
						cdat = (char)idat;
					}
					switch (cdat) {
						case 0x0a :		// this is valid because of UTF-8 !!
							bDic = true;
							sbDic.delete(0, sbDic.length());
							sbCnt.delete(0, sbCnt.length());
							break;
						case ' ' : 
							bDic = false;
							bHit = dictMatch(sbDic.toString());
							break;
						case '/' :
							if (bHit && 0 < sbCnt.length()) {
								sWork = sPre + sbCnt.toString() + sRemain;
								if (checkDup(sWork)) {
									vWork = vWork2.getLast();
									vWork2 = vWork.next = new Vect(vWork);
									if (null == vFirst) vFirst = vWork2;
									vWork2.word = sWork;
									if (0 < sRemain.length()) {
										cdat2 = sRemain.charAt(0);
										if (0 > sSetuzokusi.indexOf(cdat2)) {
											vWork2.cacheWord = sPre + sbCnt.toString() + cdat2;
											vWork2.cacheYomi = sPre + sWord.substring(0, sWord.length() - sRemain.length() + 1);
										} else {
											vWork2.cacheWord = sPre + sbCnt.toString();
											vWork2.cacheYomi = sPre + sWord.substring(0, sWord.length() - sRemain.length());
										}
									} else {
										vWork2.cacheWord = sWork;
										vWork2.cacheYomi = sPre + sWord;
									}
									vWork2.cachePosition = -1;
								}
								sbCnt.delete(0, sbCnt.length());
							}
							break;
						default :
							if (bDic) sbDic.append(cdat);
							else {
								if (bHit) sbCnt.append(cdat);
							}
					}
				}
			} catch (IOException e) {
				sError = "searchDict: " + e;
				e.printStackTrace();
			}
		}
		return vFirst;
	}
	
	private boolean checkDup(String sWork)
	{
		Vect vx, vy;

		vx = vBase.next;
		while (vx != null) {
			if (0 == vx.word.compareTo(sWork)) return false; //
			vx = vx.next;
			if (vx == v) break;
		}
		return true;
	}
	
	private boolean dictMatch(String sDic)
	{
		String sTemp = "";
		boolean bFlg = false;
		
		char cLast = sDic.charAt(sDic.length() - 1);
		if ('a' <= cLast && cLast <= 'z') {
			if (sDic.length() <= sWord.length()) {
				sTemp = sDic.substring(0, sDic.length() - 1);
				if (sWord.startsWith(sTemp)) {
					bFlg = (cLast == getIni(sWord.substring(sTemp.length())));
				}
			}
		} else {
			sTemp = sDic;
			bFlg = (sWord.startsWith(sTemp));
//			bFlg = (0 == sWord.compareTo(sTemp));
		}
		if (bFlg) {
			sRemain = sWord.substring(sTemp.length());
		}
		return bFlg;
	}
	
	private char getIni(String sWord)
	{
		char c = ' ';
		char cini = sWord.charAt(0);
		if ('' == cini) cini = sWord.charAt(1);
		switch (cini) {
			case '' : c = 'a'; break;
			case '' : c = 'i'; break;
			case '' : c = 'u'; break;
			case '' : c = 'e'; break;
			case '' : c = 'o'; break;
			case '' :
			case '' :
			case '' :
			case '' :
			case '' : c = 'k'; break;
			case '' :
			case '' :
			case '' :
			case '' :
			case '' : c = 'g'; break;
			case '' :
			case '' :
			case '' :
			case '' :
			case '' : c = 's'; break;
			case '' :
			case '' :
			case '' :
			case '' :
			case '' : c = 'z'; break;
			case '' :
			case '' :
			case '' :
			case '' :
			case '' : c = 't'; break;
			case '' :
			case '' :
			case '' :
			case '' :
			case '' : c = 'd'; break;
			case '' :
			case '' :
			case '' :
			case '' :
			case '' : c = 'n'; break;
			case '' :
			case '' :
			case '' :
			case '' :
			case '' : c = 'h'; break;
			case '' :
			case '' :
			case '' :
			case '' :
			case '' : c = 'b'; break;
			case '' :
			case '' :
			case '' :
			case '' :
			case '' : c = 'p'; break;
			case '' :
			case '' :
			case '' :
			case '' :
			case '' : c = 'm'; break;
			case '' :
			case '' :
			case '' : c = 'y'; break;
			case '' :
			case '' :
			case '' :
			case '' :
			case '' : c = 'r'; break;
			case '' :
			case '' : c = 'w'; break;
			case '' : c = 'n'; break;
			default   : c = ' ';
		}
		
		return c;
	}
	
	private boolean loadIndex()
	{
		byte[] ba = new byte[4];
		int iWork;
		boolean bFlag = true;
		RecordStore rsv = null;
		
		try {
			rsv = RecordStore.openRecordStore("dicVer", false);
			ba = rsv.getRecord(1);
			if (1 == ba[2]) bCN = true;
			if (dicVersion != ba[0] || dicType != ba[1]) {
				rsv.closeRecordStore();
				return false;
			}
		} catch (Exception e) {
//			sError = "loadIndex: " + e;
//			e.printStackTrace();
			bFlag = false;
		} finally {
			try {
				if (null != rsv) rsv.closeRecordStore();
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
		return bFlag;
	}
	
	public void storeIndex()
	{
		byte[] ba = new byte[4];
		//byte[] bIndex = new byte[48 * 4];
		int iWork;
		
		try {
			try {
				RecordStore.deleteRecordStore("dicVer");
			} catch (RecordStoreNotFoundException e) {
			}
			try {
				RecordStore.deleteRecordStore("dicIndex");
			} catch (RecordStoreNotFoundException e) {
			}
			RecordStore rsv = RecordStore.openRecordStore("dicVer", true);
			ba[0] = dicVersion;
			ba[1] = dicType;
			if (bCN) ba[2] = 1;
			else ba[2] = 0;
			ba[3] = 0;
			rsv.addRecord(ba, 0, 4);
			rsv.closeRecordStore();
		} catch (Exception e) {
			sError = "storeIndex: " + e;
			e.printStackTrace();
		}
	}

	private int getIndx(char cdat)
	{
		int pos;
		
		switch (cdat) {
			case ';'  : pos = -1; break;
			case '' : pos = 45; break;
			case '' : pos = 44; break; 
			case '' : pos = 43; break;
			case '' : pos = 42; break;
			case '' : pos = 41; break;
			case '' :
			case '' : pos = 40; break;
			case '' :
			case '' : pos = 39; break;
			case '' :
			case '' : pos = 38; break;
			case '' :
			case '' : pos = 37; break;
			case '' : 
			case '' : pos = 36; break;
			case '' : 
			case '' : pos = 35; break;
			case '' : 
			case '' : pos = 34; break;
			case '' : 
			case '' : pos = 33; break;
			case '' : 
			case '' : pos = 32; break;
			case '' :
			case '' : pos = 31; break;
			case '' : 
			case '' : pos = 30; break;
			case '' : 
			case '' : pos = 29; break;
			case '' : 
			case '' : pos = 28; break;
			case '' : 
			case '' : pos = 27; break;
			case '' : 
			case '' : pos = 26; break;
			case '' : pos = 25; break;
			case '' : pos = 24; break;
			case '' : pos = 23; break;
			case '' : pos = 22; break;
			case '' : pos = 21; break;
			case '' : 
			case '' : 
			case '' : pos = 20; break;
			case '' : 
			case '' : 
			case '' : pos = 19; break;
			case '' : 
			case '' : 
			case '' : pos = 18; break;
			case '' : 
			case '' : 
			case '' : pos = 17; break;
			case '' : 
			case '' :
			case '' : pos = 16; break;
			case '' : pos = 15; break;
			case '' : pos = 14; break;
			case '' : pos = 13; break;
			case '' : pos = 12; break;
			case '' : pos = 11; break;
			case '' : pos = 10; break;
			case '' : pos = 9; break;
			case '' : pos = 8; break;
			case '' : pos = 7; break;
			case '' : pos = 6; break;
			case '' : pos = 5; break;
			case '' : pos = 4; break;
			case '' : pos = 3; break;
			case '' : pos = 2; break;
			case '' : 
			case '' : pos = 1; break;
			default   : pos = 46; break;
		}
		return pos;
	}
}
